Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TAO_Perfect_Hash_OpTable Class Reference

Helper class for use of perfect hashing operation lookup strategy. More...

`#include <Operation_Table.h>`

Inheritance diagram for TAO_Perfect_Hash_OpTable:

[legend]
Collaboration diagram for TAO_Perfect_Hash_OpTable:

[legend]
List of all members.

## Public Methods
| TAO_Perfect_Hash_OpTable (void)
| Do nothing constructor.
virtual | ~TAO_Perfect_Hash_OpTable (void)
| Do nothing destrctor.
virtual int | find (const char *opname, TAO_Skeleton &skelfunc, const unsigned int length=0)
| See the documentation in the base class for details.
virtual int | find (const char *opname, TAO_Collocated_Skeleton &skelfunc, TAO::Collocation_Strategy s, const unsigned int length=0)
virtual int | bind (const char *opname, const TAO::Operation_Skeletons skel_ptr)
## Private Methods
virtual unsigned int | hash (const char *str, unsigned int len)=0
virtual const TAO_operation_db_entry * | lookup (const char *str, unsigned int len)=0

## Detailed Description

Helper class for use of perfect hashing operation lookup strategy.

This class declares pure virtual methods called 'lookup ()' and 'hash ()' which will be generated by the GPERF program. These methods are used by 'bind ()' and 'find ()' methods. Subclasses will define the lookup and hash functions.

## Constructor & Destructor Documentation

TAO_Perfect_Hash_OpTable::TAO_Perfect_Hash_OpTable | ( | void |  | ) |

| Do nothing constructor.

TAO_Perfect_Hash_OpTable::~TAO_Perfect_Hash_OpTable | ( | void |  | ) | `[virtual]`

| Do nothing destrctor.

## Member Function Documentation

int TAO_Perfect_Hash_OpTable::bind | ( | const char * | opname,
|  | const TAO::Operation_Skeletons | skel_ptr
| ) | `[virtual]`

| Associate the skeleton <{skel_ptr}> with an operation named <{opname}>. Returns -1 on failure, 0 on success, 1 on duplicate. Implements TAO_Operation_Table.

int TAO_Perfect_Hash_OpTable::find | ( | const char * | opname,
|  | TAO_Collocated_Skeleton & | skelfunc,
|  | TAO::Collocation_Strategy | s,
|  | const unsigned int | length = 0
| ) | `[virtual]`

| Uses <{opname}> to look up the collocated skeleton function and pass it back in <{cskelfunc}>. Returns non-negative integer on success, or -1 on failure. Implements TAO_Operation_Table.

int TAO_Perfect_Hash_OpTable::find | ( | const char * | opname,
|  | TAO_Skeleton & | skelfunc,
|  | const unsigned int | length = 0
| ) | `[virtual]`

| See the documentation in the base class for details. Implements TAO_Operation_Table.

virtual unsigned int TAO_Perfect_Hash_OpTable::hash | ( | const char * | str,
|  | unsigned int | len
| ) | `[private, pure virtual]`

| Implemented in TAO_ImplementationRepository_ServerObject_Perfect_Hash_OpTable, TAO_ImplementationRepository_Administration_Perfect_Hash_OpTable, TAO_ImplementationRepository_ServerInformationIterator_Perfect_Hash_OpTable, TAO_ImplementationRepository_Locator_Perfect_Hash_OpTable, and TAO_CORBA_Policy_Perfect_Hash_OpTable.

virtual const TAO_operation_db_entry* TAO_Perfect_Hash_OpTable::lookup | ( | const char * | str,
|  | unsigned int | len
| ) | `[private, pure virtual]`

| Implemented in TAO_ImplementationRepository_ServerObject_Perfect_Hash_OpTable, TAO_ImplementationRepository_Administration_Perfect_Hash_OpTable, TAO_ImplementationRepository_ServerInformationIterator_Perfect_Hash_OpTable, TAO_ImplementationRepository_Locator_Perfect_Hash_OpTable, and TAO_CORBA_Policy_Perfect_Hash_OpTable.

The documentation for this class was generated from the following files:

- Operation_Table.h
- Operation_Table.cpp